'''
Created on Sep 18, 2012

@author: pascale
'''
# -*- coding: utf-8 -*-

import wx
import rmodel
import util 
import cloud
import locale
import wxmpl
import numpy
import matplotlib
import wx.lib.agw.floatspin as FS
itemColor={'Q':"red",'O3':"green",'CO2':"magenta",'CH4':"cyan",'CO':"yellow", 'N2O':"black","T":"blue",
              'INSO':"Coral",'WASO':"crimson",'SOOT':"chocolate",'SSAM':"yellow",'SSCM':"orange",'MINM':"black",
              'MIAM':"aqua",'MICM':"BlueViolet",'MITR':"brown",  'SUSO':"CadetBlue",'VOLA':"magenta",'VAPO':"green",'ASDU':"red",
              'STCO':"red", 'STMA':"green", 'CUCC':"magenta", 'CUCP':"cyan", 'CUMA':"yellow", 'CIRR':"blue",'CFRAC':"brown","CLW":"green"}

itemMarker={'Q':"_",'O3':"_",'CO2':"_",'CH4':"_",'CO':"_", 'N2O':"_","T":"_",
              'INSO':"+",'WASO':"+",'SOOT':"+",'SSAM':"+",'SSCM':"+",'MINM':"+",
              'MIAM':"+",'MICM':"+",'MITR':"+",  'SUSO':"+",'VOLA':"+",'VAPO':"+",'ASDU':"+",
              'STCO':"*", 'STMA':"*", 'CUCC':"*", 'CUCP':"*", 'CUMA':"*", 'CIRR':"*",'CFRAC':"*","CLW":"*"
              }
kindOfItem={'Q':"GASES",'O3':"GASES",'CO2':"GASES",'CH4':"GASES",'CO':"GASES", 'N2O':"GASES","T":"GASES",
              'INSO':"AEROSOLS",'WASO':"AEROSOLS",'SOOT':"AEROSOLS",'SSAM':"AEROSOLS",'SSCM':"AEROSOLS",'MINM':"AEROSOLS",
              'MIAM':"AEROSOLS",'MICM':"AEROSOLS",'MITR':"AEROSOLS",  'SUSO':"AEROSOLS",'VOLA':"AEROSOLS",'VAPO':"AEROSOLS",'ASDU':"AEROSOLS",
              'STCO':"CLOUDS", 'STMA':"CLOUDS", 'CUCC':"CLOUDS", 'CUCP':"CLOUDS", 'CUMA':"CLOUDS", 'CIRR':"CLOUDS",'CFRAC':"CLOUDS","CLW":"CLOUDS"
              }
#from matplotlib.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
axesDef={"GASES":     {"xlimits":None ,"xscale":"log","ylimits":None,"yscale":"log"},
         "AEROSOLS":  {"xlimits":(0.001,100000),"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
         "CLOUDS":    {"xlimits":(0,1.8),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
         'Q':   {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'O3':  {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CO2': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CH4': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CO':  {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          'N2O': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          "T":   {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          'INSO':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"}, 
          'WASO':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'SOOT':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'SSAM':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'SSCM':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'MINM':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'MIAM':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'MICM':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'MITR':   {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'SUSO':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'VOLA':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'VAPO':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'ASDU':  {"xlimits":None,"xscale":"log","ylimits":(1100,0.5),"yscale":"log"},
          'STCO':   {"xlimits":(0,1),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'STMA':    {"xlimits":(0,1),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUCC':    {"xlimits":(0,1.5),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUCP':   {"xlimits":(0,1.5),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUMA':   {"xlimits":(0,1.5),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CIRR':   {"xlimits":(0,1),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CFRAC':   {"xlimits":(0,1),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
           "CLW":   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
                 
         }

locale.setlocale(locale.LC_ALL, '')

class ComputeDialog(wx.Dialog):
    def __init__(
            self, parent, ID, title, text="",pmin0=0,pmax0=1000,scale0=1.,offset0=0.,increment=None,size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE,
            useMetal=False,limits_scale=(0.01,10),limits_offset=(-100,100)
            ):

        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.
        if increment == None : increment=10.
        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.
        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)


        # Now continue with the normal construction of the dialog
        # contents
        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, text)
        label.SetHelpText("help text")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        # box 1 pmin
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "p min:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.pminFS = FS.FloatSpin(self, -1, min_val=0.00001, max_val=1150,digits=3,value=pmin0,
                                 increment=increment, agwStyle=FS.FS_LEFT) 
        box.Add(self.pminFS, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        
        # box 2 pmax
        box = wx.BoxSizer(wx.HORIZONTAL)
        label = wx.StaticText(self, -1, "p max:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.pmaxFS = FS.FloatSpin(self, -1, min_val=0.00001, max_val=1150,digits=3,value=pmax0,
                                 increment=increment, agwStyle=FS.FS_LEFT) 
        box.Add(self.pmaxFS, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        
        # box 3 scale
        box = wx.BoxSizer(wx.HORIZONTAL)
        label = wx.StaticText(self, -1, "scale:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.scale= FS.FloatSpin(self, -1, min_val=limits_scale[0], max_val=limits_scale[1],digits=2,value=scale0,
                                 increment=1, agwStyle=FS.FS_LEFT) 
        box.Add(self.scale, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
         
        # box 4 offset     
        label = wx.StaticText(self, -1, "offset:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.offset= FS.FloatSpin(self, -1, min_val=limits_offset[0], max_val=limits_offset[1],digits=3,value=offset0,
                                 increment=1, agwStyle=FS.FS_LEFT) 
        box.Add(self.offset, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        # buttons
        btnsizer = wx.StdDialogButtonSizer()
        
        btn = wx.Button(self, wx.ID_OK)
       
        btn.SetDefault()
        btnsizer.AddButton(btn)
        btn = wx.Button(self, wx.ID_CANCEL)
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)
        self.Show()
        
    def GetSelections(self):
   
        return (self.pminFS.GetValue(),self.pmaxFS.GetValue(),self.scale.GetValue(),self.offset.GetValue())
class AxesDialog(wx.Dialog):
    def __init__(
            self, parent, ID, title, text="",xmin0=0,xmax0=0,scale="linear",increment=None,size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE,
            useMetal=False,
            ):

        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.
        if increment == None: increment=10
        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.
        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)


        # Now continue with the normal construction of the dialog
        # contents
        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, text)
        label.SetHelpText("help text")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        # box 1 xmin
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "x min:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.xminFS = FS.FloatSpin(self, -1, min_val=0, max_val=1000000000,digits=2,value=xmin0,
                                 increment=increment, agwStyle=FS.FS_LEFT) 
        box.Add(self.xminFS, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        
        # box 2 xmax
        box = wx.BoxSizer(wx.HORIZONTAL)
        label = wx.StaticText(self, -1, "x max:")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.xmaxFS = FS.FloatSpin(self, -1, min_val=0, max_val=1000000000,digits=2,value=xmax0,
                                 increment=increment, agwStyle=FS.FS_LEFT) 
        box.Add(self.xmaxFS, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        
#        # box 3 scale
#        box = wx.BoxSizer(wx.HORIZONTAL)
#        label = wx.StaticText(self, -1, "xscale:")
#        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
#        self.scale= wx.ComboBox(self,choices=["linear","log"],value=scale,size=(180,30))
#        box.Add(self.scale, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
#        sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
#        
#        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
#        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        # buttons
        btnsizer = wx.StdDialogButtonSizer()
        
        btn = wx.Button(self, wx.ID_OK)
       
        btn.SetDefault()
        btnsizer.AddButton(btn)
        btn = wx.Button(self, wx.ID_CANCEL)
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)
        self.Show()
        
    def GetSelections(self):
        return (self.xminFS.GetValue(),self.xmaxFS.GetValue())
        #return (self.xminFS.GetValue(),self.xmaxFS.GetValue(),self.scale.GetValue())

#---------------------------------------------------------------------------

class Data(wxmpl.Channel):
    """ Class to keep data for the PlotItemPanel data """
    def __init__(self,x,y,theName="",theColor=None,theStyle=None,theMarker=None):
        wxmpl.Channel.__init__(self,name=theName,color=theColor,style=theStyle,marker=theMarker)
        self.x=x
        self.y=y
    def getX(self):
        return self.x
    def getY(self):
        return self.y
    def myUpdate(self,x,y):
        self.x=numpy.zeros(x.shape[0])+x
        self.y=numpy.zeros(y.shape[0])+y
        self.setChanged('True')
    
class PlotItemPanel(wxmpl.PlotPanel):
    """ plot on a PlotPanel one curve """
   
    def __init__(self,parent,value,pression,theName,liste_item=None,kind="GASES",xlegend="ppmv",layer=None):
        self.theName=theName
        self.theParent=parent
        self.xlegend=xlegend
        self.kind=kind
        self.layer=layer
        self.pression=pression
        self.value=value
        self.myCloud=None
        wxmpl.PlotPanel.__init__(self,parent,-1,None,autoscaleUnzoom=False) 
        self.onInsert=True
        self.OnPlot()
        if self.theParent.GetParent().GetParent().edit :
            #wxmpl.EVT_POINT(self,self.GetId(),self._on_point)
            self.ConnectCanvasEVT_POINT(self._on_point)
        self.valueHistory=[]
        self.valueHistoryRedo=[]
        
    def ConnectCanvasEVT_POINT(self,methode):
        #wxmpl.EVT_POINT(self,self.GetId(),self._on_point)
        self.cid=self.get_figure().canvas.mpl_connect("button_release_event",methode)
    
    def DisconnectCanvasEVT_POINT(self):
        self.get_figure().canvas.mpl_disconnect(self.cid)
        
    def SetXlimits(self,theName=None,xmin=None,xmax=None):
        """ set x limits """   

        if axesDef[self.theName]["xlimits"] != None : self.axes.set_xlim(axesDef[self.theName]["xlimits"])
        #if axesDef[self.theName]["ylimits"] != None : self.axes.set_ylim(axesDef[self.theName]["ylimits"])
        self.axes.set_xscale(axesDef[self.theName]["xscale"])
        #self.axes.set_yscale(axesDef[self.theName]["yscale"])

          
    def Update(self):
        self.stripCharter.update()  
   
    def UpdateData(self,dataX):
        self.x=dataX
        self.data.setChanged(True)
        if self.kind != "CLOUDS" :
            self.data.myUpdate(self.x, self.y)
        else :
            (self.xcloud,self.ycloud)=self.myCloud.computeCloudLine(cloud=dataX)
            self.data.myUpdate(self.xcloud, self.ycloud)    
        self.stripCharter.update()
        
    def OnPlot(self):
        fig=self.get_figure()   
        self.axes=fig.gca() 
        self.x=self.value[::1]
        self.axes.set_ylim((self.pression[-1],self.pression[0]))
        self.axes.set_yscale("log")  
        self.axes.set_yticks((0.00005,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
        label=('5e-5','1e-4','2e-4','5e-4','1e-3','2e-3','5e-3','0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000') 
        self.axes.set_ylim((self.pression[-1],self.pression[0]))              
        if self.kind == "GASES" :     
            self.y=self.pression[::1]        
#            self.axes.set_ylim((self.pression[-1],self.pression[0]))
#            self.axes.set_yscale("log")  
#            self.axes.set_yticks((0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
#            label=('0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000')                 
        else : 
            self.y=self.layer[::1]
#            self.axes.set_ylim((self.pression[-1],0.5))
#            self.axes.set_yscale("log")                
#            self.axes.set_yticks((0.5,1,2,5,10,25,50,100,200,300,500,1000))
#            label=('0.5','1','2','5','10','25','50','100','200','300','500','1000')   
        if self.kind != "CLOUDS" :                       
            self.data=Data(self.x,self.y,theName=self.theName,theColor=itemColor[self.theName],theMarker=itemMarker[self.theName])
        else :
            self.myCloud=cloud.Cloud(self.x,self.pression)
            (self.xcloud,self.ycloud)=self.myCloud.computeCloudLine()
            self.data=Data(self.xcloud,self.ycloud,theName=self.theName,theColor=itemColor[self.theName],theMarker=itemMarker[self.theName])
            
        self.axes.set_xlabel(self.xlegend)
        self.axes.set_ylabel('pressure (hPa)')
             
        for tick in self.axes.xaxis.get_major_ticks():
                tick.label.set_fontsize(10)  
        for tick in self.axes.yaxis.get_major_ticks():
                tick.label.set_fontsize(10)
                
        self.SetXlimits(self.theName)

        self.axes.grid(True,axis='both') 
        self.axes.set_yticklabels(label) 
        
        self.stripCharter=wxmpl.StripCharter(self.axes)
        
        self.myChannelList=[]
        self.myChannelList.append(self.data)        
        self.stripCharter.setChannels(self.myChannelList)
        if wx.Platform == '__WXMAC__':  
            self.Update()       
   
    def _on_point(self,e):
        # for undo
        
        wx.BeginBusyCursor() 
        wx.SafeYield(None, True)
                
        if  self.kind != "CLOUDS"  :
            y=numpy.zeros(self.x.shape[0])+self.x
            self.valueHistory.append(y)
            mini=1000
            for index in range(self.y.shape[0]) :
                dist=abs(self.y[index]-e.ydata)
                if dist < mini :
                    imin=index
                    mini=dist
            if self.kind != "GASES" and not self.onInsert :
                self.x[imin]=0
            else :     
                self.x[imin]=  e.xdata 
            self.data.setChanged(True)
            self.data.myUpdate(self.x, self.y)
            self.stripCharter.update()
            # Update Panel 1 : not a good thinks to do here send an event would be better?
            self.UpdateAllGraphics()
        else :
            
            y=numpy.zeros(self.xcloud.shape[0])+self.xcloud
            self.valueHistory.append(y)
            mini=1000
            for index in range(self.ycloud.shape[0]) :
                dist=self.ycloud[index]-e.ydata
                if dist < mini and dist > 0:
                    imin=index
                    mini=dist   
           
            
            if not self.onInsert :
                self.xcloud[imin]=0
                if imin%2!=0 : # we have 2 points to move and its depends if imini is odd 
                    if imin != self.xcloud.shape[0] : self.xcloud[imin+1]=0
                else :
                    if imin != 0 : self.xcloud[imin-1]=0          
            else :     
                self.xcloud[imin]=  e.xdata 
                if imin%2!=0 : # we have 2 points to move and its depends if imini is odd
                    if imin != self.xcloud.shape[0] : self.xcloud[imin+1]=e.xdata 
                else :
                    if imin !=0 : self.xcloud[imin-1]=e.xdata   
                
            self.data.setChanged(True)
            self.data.myUpdate(self.xcloud, self.ycloud)
            self.x=self.myCloud.getCloud(self.xcloud)
            self.stripCharter.update()
            # Update Panel 1 : not a good thinks to do here send an event would be better?
            self.UpdateAllGraphics()
        
        wx.EndBusyCursor() 

        if self.HasCapture() : self.ReleaseMouse()
        
   
            
    def ComputeProfile (self,pmin,pmax,scale,offset):
        if  self.kind != "CLOUDS"  :
            y=numpy.zeros(self.x.shape[0])+self.x
            self.valueHistory.append(y) 
            for i in range(self.x.shape[0]):
                p=self.pression[i]
                if p >= pmin and p <= pmax :
                    val=self.x[i]
                    self.x[i]=max(0.0001,scale*val+offset)
            self.data.setChanged(True)
            self.data.myUpdate(self.x, self.y)
            self.stripCharter.update()
            # Update Panel 1 : not a good thinks to do here send an event would be better?
            self.UpdateAllGraphics()
        else :     
            y=numpy.zeros(self.xcloud.shape[0])+self.xcloud
            self.valueHistory.append(y)
            for i in range(self.xcloud.shape[0]):
                p=self.ycloud[i]  
                if p >= pmin and p <= pmax :
                    self.xcloud[i]=max(0,scale*self.xcloud[i]+offset)
            self.data.setChanged(True)
            self.data.myUpdate(self.xcloud, self.ycloud)
            self.x=self.myCloud.getCloud(self.xcloud)
            self.stripCharter.update()
            # Update Panel 1 : not a good thinks to do here send an event would be better?
            self.UpdateAllGraphics()


        
    def OnRedo(self):      
        if self.valueHistoryRedo != [] :
            if self.kind != "CLOUDS" :
                X=numpy.zeros(self.x.shape[0])+self.x
                self.valueHistory.append(X)
                X=self.valueHistoryRedo.pop()
                self.x=numpy.zeros(X.shape[0])+X
                self.data.myUpdate(self.x, self.y)
            else :
                X=numpy.zeros(self.xcloud.shape[0])+self.xcloud
                self.valueHistory.append(X)
                X=self.valueHistoryRedo.pop()
                self.xcloud=numpy.zeros(X.shape[0])+X
                self.x=self.myCloud.getCloud(self.xcloud)
                self.myCloud.update(self.xcloud,self.ycloud)
                self.data.myUpdate(self.xcloud, self.ycloud)
            self.Update()
            self.UpdateAllGraphics()
            
    def OnUndo(self):     
        
        if self.valueHistory != [] :
            if self.kind != "CLOUDS" :
                X=numpy.zeros(self.x.shape[0])+self.x
                self.valueHistoryRedo.append(X)
                X=self.valueHistory.pop()
                self.x=numpy.zeros(X.shape[0])+X
                self.data.myUpdate(self.x, self.y)
            else : 
                X=numpy.zeros(self.xcloud.shape[0])+self.xcloud
                self.valueHistoryRedo.append(X)
                X=self.valueHistory.pop()
                self.xcloud=numpy.zeros(X.shape[0])+X
                self.x=self.myCloud.getCloud(self.xcloud)
                self.data.myUpdate(self.xcloud, self.ycloud)
                    
            self.Update()
            self.UpdateAllGraphics()
               
    def GetItem(self):
        if self.kind != "CLOUDS" :
            return self.data.getX()
        else :
            return self.myCloud.getCloud(self.data.getX())
     
    def UpdateAllGraphics(self):  
        """ update the left panel but this method is not clean it would be better to send an event"""
        aProfile=self.theParent.GetParent().GetParent().GetProfile()
        aProfile[self.theName]=self.x
        self.theParent.GetParent().GetParent().allGraphicsPages[self.kind].UpdateData(aProfile,self.theName)
        if self.theName == "T" :
            for kind in ("AEROSOLS","CLOUDS") :
                if self.theParent.GetParent().GetParent().allGraphicsPages.has_key(kind) : 
                    self.theParent.GetParent().GetParent().allGraphicsPages[kind].UpdateData(aProfile,self.theName)
        
class PlotItemPanelAll(wxmpl.PlotPanel):
    """ Plot all gas in the same graphic """

    def __init__(self,parent,theProfile,kind="GASES",layer=None):
        self.myProfile=theProfile
        self.layer=layer
        wxmpl.PlotPanel.__init__(self,parent,-1,None)
        self.kind=kind
        self.itemsList={}
        self.itemsList['GASES']=self.myProfile.gas_list
        self.itemsList['AEROSOLS']=self.myProfile.aerosol_list
        self.itemsList['CLOUDS']=self.myProfile.cloud_list
        self.labelx={}
        self.labelx['GASES']= 'ppmv'
        self.labelx['AEROSOLS']='number density (cm-3)'
        self.labelx['CLOUDS']='layer mean content (g/m3)'
        self.OnPlot()
        
    def OnPlot(self,theProfile=None):   

        matplotlib.rc('xtick', labelsize=10) 
        matplotlib.rc('ytick', labelsize=10) 
        if theProfile != None : self.myProfile=theProfile
        pression=self.myProfile['P']
        fig=self.get_figure()   
        fig.clear()
        self.axes=fig.gca()  
        self.axes.set_xscale('log') 
        self.axes.set_yscale('log') 
         
        self.data={}
        self.stripCharter=wxmpl.StripCharter(self.axes,loc_legend="center right")  
                   
        self.axesT=self.axes.twiny()
        self.axesT.set_xlabel('temperature(K)')
        self.axes.set_ylim((pression[-1],pression[0]))   
        if self.kind == "GASES" :
            #self.axes.set_ylim((pression[-1],pression[0]))
            markerFlag=False
        else :
            markerFlag=True
            #self.axes.set_ylim((pression[-1],0.5))  

            
        self.stripCharterT=wxmpl.StripCharter(self.axesT,loc_legend="upper right")
        
        self.myChannelList=[]
        self.myChannelListT=[]
        
        if self.kind == 'GASES' :
            y=self.myProfile['P'][::1]
            self.axes.set_xlabel('ppvm')
        else :
            y=self.layer[::1]   
        if self.kind == "AEROSOLS" :
            self.axes.set_xlim((0.001,100000))
             
        if self.kind == "CLOUDS" :
            self.axes.set_xlim((0.001,1000))
        
        self.axes.grid(True,axis='both')
        self.axes.set_xlabel( self.labelx[self.kind] )
             
        for item in self.itemsList[self.kind]:
            if self.myProfile[item] != None :
                x=self.myProfile[item][::1]
                if markerFlag :
                    self.data[item]=Data(x,y,theName=item,theColor=itemColor[item],theMarker=itemMarker[item])
                else :
                    self.data[item]=Data(x,y,theName=item,theColor=itemColor[item]) 
                self.myChannelList.append(self.data[item])
                
        x=self.myProfile['T'][::1]
        y=self.myProfile['P'][::1]
        self.data['T']=Data(x,y,theName='T',theColor=itemColor['T'])  
        self.myChannelListT.append(self.data['T'])    
        
        self.axes.set_ylabel('pressure (hPa)') 
        self.axes.set_yticks((0.00005,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
        label=('5e-5','1e-4','2e-4','5e-4','1e-3','2e-3','5e-3','0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000')
#        if self.kind == "GASES" :
#            self.axes.set_yticks((0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
#            label=('0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000')
#        else :
#            self.axes.set_yticks((0.5,1,2,5,10,25,50,100,200,300,500,1000))
#            label=('0.5','1','2','5','10','25','50','100','200','300','500','1000')   
        self.axes.set_yticklabels(label)
        self.axesT.set_ylim((pression[-1],pression[0]))
        self.axes.set_ylim((pression[-1],pression[0])) 
        for tick in self.axes.xaxis.get_major_ticks():
            tick.label.set_fontsize(10)  

        self.stripCharter.setChannels(self.myChannelList)
        self.stripCharterT.setChannels(self.myChannelListT)
        if wx.Platform == '__WXMAC__':  
            self.Update()       

    def Update(self):     
        self.stripCharter.update()
        self.stripCharterT.update()
        
    def UpdateData(self,profile,itemName):
        """ Update the data with the profile and update the graphic 
            this method can't be used if there is a modification in number of gas or number of layers
            use OnPlot in this case """ 
        self.myProfile=profile 
        if self.myProfile[itemName] != None :
            if self.kind != 'GASES'  and itemName != 'T' and itemName != "CFRAC" :
                self.data[itemName].myUpdate(self.myProfile[itemName],self.layer)
            else :   
                if itemName != "CFRAC" :  
                    self.data[itemName].myUpdate(self.myProfile[itemName],self.myProfile['P'])
        self.stripCharter.update()
        self.stripCharterT.update()
        
       
class MyNotebook(wx.Notebook):     
#import wx.lib.agw.flatnotebook # test for macos
#class MyNotebook(wx.lib.agw.flatnotebook.FlatNotebook):
    """ MyNotebook Class inherits from Notebook 
        Bind the event EVT_NOTEBOOK_PAGE_CHANGED with Update method of the page """
    def __init__(self,parent,isRightPage=True):
        wx.Notebook.__init__(self, parent, id=wx.ID_ANY, style=
                             wx.BK_DEFAULT
                             )
#        wx.lib.agw.flatnotebook.FlatNotebook.__init__(self, parent, id=wx.ID_ANY, style=
#                             wx.lib.agw.flatnotebook.FNB_NO_X_BUTTON   # does not work
#                             )
        self.parent=parent  
        self.isRightPage=isRightPage   
        self.BindEvent()   
          
    def BindEvent(self):
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED,self.OnPageChanged)
        
    def OnPageChanged(self,event):  
        sel = self.GetSelection()
        thePage=self.GetPage(sel)
        thePage.Update()
#        if self.isRightPage :
#            item=thePage.theName

        
        event.Skip()     

class ProfileView(util.GenericViewRadio):
    """ Profile window of the application """        
    helpTitle="Help Profile"
    helpMessage="""
    Select and visualize a component profile on the right panel
    Click the middle button to modify the profile.
    Click left and drag a zone to zoom in.
    Click right button to zoom out. 
    Apply your changes or save the profile 
    for the next run of RTTOV.    
              
        """
    
    def __init__(self, parent,profile,edit=True,controler=None):
        self.edit=edit
        self.myProfile=profile
        self.my_list_cloud=[]
        self.myControler=controler
        for cloud in  self.myProfile.cloud_list :  self.my_list_cloud.append(cloud)
        self.my_list_cloud.append("CFRAC")
        self.my_list_cloud.append("CLW")
        util.GenericView.__init__(self, parent,  "profile")
      
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(sizer)
        self.CreateMenuBar()
        self.SetSize((1300, 700))
        self.SetMinSize((1300, 700))
        self.SetTitle('PROFILE EDITOR') 
        self._ComputeLevels(self.myProfile['P'])
        # panel 1 notebook with all curves (GASES, AEROSOLS, CLOUDS)
        self.panel1 =wx.Panel(self, -1,style=wx.BORDER_SIMPLE)
        
        self.panel1.SetSize((200,500))
        sizer.Add(self.panel1,1,wx.EXPAND)
        # creation of notebook for the panel 1
        self.nb_all=MyNotebook(self.panel1,isRightPage=False)

        sizer1=wx.BoxSizer()
        sizer1.Add(self.nb_all,1,wx.EXPAND)
        self.panel1.SetSizer(sizer1)
        
        # panel 2 notebook with one curve 
        self.panel2 = wx.Panel(self, -1,style=wx.BORDER_SIMPLE)
        sizer.Add(self.panel2,1,wx.EXPAND)
        # creation of the notebook for the panel 2
        self.nb=MyNotebook(self.panel2  )
        self.axesDef=[]
        
        # creation des graphiques
        self.Plot(self.myProfile)
              
        # create a second sizer for the notebook
        sizer2=wx.BoxSizer()
        sizer2.Add(self.nb,1,wx.EXPAND)
        self.panel2.SetSizer(sizer2)
        self.sb = self.CreateStatusBar()
        self.sb.SetBackgroundColour('WHITE')
        txt = ''
        self.sb.SetStatusText(txt)
        self.Centre()
        self.Show(True) 
        self.Bind(wx.EVT_CLOSE,self.OnClose)
        
       
    def PlotLeft(self,profile=None):      
        # plot panel 1 with all gas
        self.allGraphicsPages={}
        self.allGraphicsPages['GASES']=PlotItemPanelAll(self.nb_all,self.myProfile,kind='GASES')
        self.nb_all.AddPage(self.allGraphicsPages['GASES'],'GASES')
         
        
        if  self.myProfile.anyAerosol() :  
            self.allGraphicsPages['AEROSOLS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="AEROSOLS",layer=self.layer)
            self.nb_all.AddPage(self.allGraphicsPages['AEROSOLS'],'AEROSOLS')
       
        if  self.myProfile.anyCloud() :  
            self.allGraphicsPages['CLOUDS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="CLOUDS",layer=self.layer)
            self.nb_all.AddPage(self.allGraphicsPages['CLOUDS'],'CLOUD')
    
    def Plot(self,profile=None):
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLevels(self.myProfile['P'])
        self.graphicPages={}     
        self.graphicPages['T']=PlotItemPanel(self.nb,self.myProfile['T'],self.myProfile['P'],theName='T',xlegend="temperature (K)")   
        self.nb.AddPage(self.graphicPages['T'],'T')          
        
        for gas in self.myProfile.gas_list :
            if self.myProfile[gas] != None :
                self.graphicPages[gas]=PlotItemPanel(self.nb,self.myProfile[gas],self.myProfile['P'],theName=gas)   
                self.nb.AddPage(self.graphicPages[gas],gas)
                
        if  self.myProfile.anyAerosol() :       
            for aerosol in self.myProfile.aerosol_list :   
                if self.myProfile[aerosol] != None :
                    self.graphicPages[aerosol]=PlotItemPanel(self.nb,self.myProfile[aerosol],self.myProfile['P'],theName=aerosol,kind="AEROSOLS",xlegend="number density (cm-3)",layer=self.layer)   
                    self.nb.AddPage(self.graphicPages[aerosol],aerosol)
                    
        if  self.myProfile.anyCloud() :       
            for cloud in  self.my_list_cloud :   
                if self.myProfile[cloud] != None :
                    if cloud == "CFRAC" : 
                        mylegend="CFRAC"
                    else :
                        mylegend=  "layer mean content (g/m3)" 
                    self.graphicPages[cloud]=PlotItemPanel(self.nb,self.myProfile[cloud],self.myProfile['P'],theName=cloud,kind="CLOUDS",xlegend=mylegend,layer=self.layer)   
                    self.nb.AddPage(self.graphicPages[cloud],cloud)
                    
       # delete empty graphicPages
        for key in self.graphicPages.keys() :
            if self.myProfile[key] == None :
                del self.graphicPages[key]
      
                        
        # plot panel 1 with all gas
        self.allGraphicsPages={}
        self.allGraphicsPages['GASES']=PlotItemPanelAll(self.nb_all,self.myProfile,kind='GASES')
        self.nb_all.AddPage(self.allGraphicsPages['GASES'],'GASES')
         
        
        if  self.myProfile.anyAerosol() :  
            self.allGraphicsPages['AEROSOLS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="AEROSOLS",layer=self.layer)
            self.nb_all.AddPage(self.allGraphicsPages['AEROSOLS'],'AEROSOLS')
       
        if  self.myProfile.anyCloud() :  
            self.allGraphicsPages['CLOUDS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="CLOUDS",layer=self.layer)
            self.nb_all.AddPage(self.allGraphicsPages['CLOUDS'],'CLOUD')
    
    def _ComputeLevels(self,pression):
        """ Compute the mean value of pression in a layer """
        foo=numpy.empty(pression.shape[0]-1)
        for i in range(foo.shape[0]) :
            foo[i]=(pression[i+1]+pression[i])/2
        self.layer=foo      
    
    def _MakeBinding(self):
        """ set the trivial Binding for the View """
        # binding cancel button
     
    def GetProfile(self):
        """ return the profile as modified by the edition frame """
        for gas in self.myProfile.gas_list :
            if self.myProfile[gas]!= None :
                self.myProfile[gas] = self.graphicPages[gas].GetItem()
        if self.myProfile.anyAerosol :        
            for aerosol in self.myProfile.aerosol_list :
                if self.myProfile[aerosol]!= None :
                    self.myProfile[aerosol] = self.graphicPages[aerosol].GetItem()
                    
        if self.myProfile.anyCloud :        

            for item in self.my_list_cloud :
                if self.myProfile[item]!= None :
                    self.myProfile[item] = self.graphicPages[item].GetItem()
        
         
             
        return self.myProfile         
        
             
    def RePlotAll(self,profile=None):
        """ Plot the 2 panels with (new) profile (delete everything before redraw) """
       
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLevels(self.myProfile['P'])
        # remove all pages of the notebook 
        self.nb.DeleteAllPages()
        self.nb_all.DeleteAllPages()
        self.Plot()
        
    def RePlotAllLeftPanel(self,profile=None):
        """ Plot the 2 panels with (new) profile (delete everything before redraw) """
       
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLevels(self.myProfile['P'])
        # remove all pages of the notebook         
        self.nb_all.DeleteAllPages()
        self.PlotLeft()
     
    def deleteRightPage(self,item):
        """ delete the item page """
        # delete the notebook page
        # delete the graphic page  
        for i in range(self.nb.GetPageCount()) :
            if self.nb.GetPageText(i) == item :
                self.nb.DeletePage(i)
                self.graphicPages.pop(item)
                break
        kind=kindOfItem[item]
        if kind == "CLOUDS" and not self.myProfile.anyCloud():
            if self.graphicPages.has_key('CFRAC') :
                self.deleteRightPage('CFRAC')
            if self.graphicPages.has_key('CLW') :
                self.deleteRightPage('CLW') 
               
    def addRightPage(self,item):
        """ add an new item page  """
        kind=kindOfItem[item]
        if kind == "GASES" :
            myY=self.myProfile['P']
        else :
            myY=self.layer    
        self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend=self.myProfile[item+'_ATTRIBUTE']['UNITS'],layer=myY)   
        self.nb.AddPage(self.graphicPages[item],item)
        if kind == "CLOUDS" :
            if not self.graphicPages.has_key('CFRAC') :
                item='CFRAC'
                self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend="CFRAC",layer=myY)   
                self.nb.AddPage(self.graphicPages[item],item)
            if not self.graphicPages.has_key('CLW') and self.myProfile['CLW'] != None :
                item = "CLW"
                self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend="CLW",layer=myY)   
                self.nb.AddPage(self.graphicPages[item],item)
                
    def replotLeftPage(self):
        """ replot the left panel """
        # TOFO ne marche pas
        self.RePlotAllLeftPanel() 
       
    def OnUndo(self,e):       
        pageName=self.nb.GetPage(self.nb.GetSelection()).theName
        self.graphicPages[pageName].OnUndo()

        
    def OnRedo(self,e):    
        pageName=self.nb.GetPage(self.nb.GetSelection()).theName
        self.graphicPages[pageName].OnRedo()
                     
    def OnClose(self,e):
        """ close the profile windows"""
        if self.myControler != None :
            self.myControler.profileView=None
        self.Destroy()    
    
    def OnControlCFRAC(self):
        """ Contrl CFRAC versus Clouds and update the graphic if necessary """
        self.myProfile.ctrlCoherenceClouds()
        if self.graphicPages.has_key('CFRAC') : 
            self.graphicPages['CFRAC'].UpdateData(self.myProfile['CFRAC'])
        
    def OnSaveProfile(self,e):
        """ return the name for a profile File """
        self.myProfile=self.GetProfile()        
        self.OnControlCFRAC()
        fileSaved=self.OnSaveFile(e,"Save a profile")
        return fileSaved

    
    def OnApplyChange(self,e):
        self.myProfile=self.GetProfile()  
        self.OnControlCFRAC()
        return self.myProfile
    
    def OnSaveProfileAs(self,e):
        """ return the name for a profile File """
        self.myProfile=self.GetProfile()
        self.OnControlCFRAC()
        fileSaved=self.OnSaveFile(e,"Save a profile")
        return fileSaved   
    
    def OnInsert(self,e):
        for item in self.graphicPages.keys() :
            self.graphicPages[item].onInsert=True  
        
    def OnRemove(self,e):
        for item in self.graphicPages.keys() :
            self.graphicPages[item].onInsert=False
            
    def UpdateListes(self):
        pass
                    
    def OnAddgas(self,e):
        self.changeItem(self.myProfile.gas_list,"no gas to add",
                   "Choose the gases to add to the profile",self.myProfile.addGas,False)
        
    def OnAddAerosol(self,e):
        self.changeItem(self.myProfile.aerosol_list,"no aerosol to add",
                   "Choose the aerosols to add to the profile",self.myProfile.addAerosol,False,kind="AEROSOLS")
         
    def OnAddCloud(self,e):
        self.changeItem(self.myProfile.cloud_list,"no cloud to remove",
                   "Choose the clouds to add to the profile",self.myProfile.addCloud,False,kind="CLOUDS")
        
    def OnRemovegas(self,e):
        self.changeItem(self.myProfile.gas_list,"no gas to remove",
                   "Choose the gases to remove from the profile",self.myProfile.removeGas)  
        
    def OnRemoveAerosol(self,e):
        self.changeItem(self.myProfile.aerosol_list,"no aerosol to remove",
                   "Choose the aerosols to remove from the profile",self.myProfile.removeAerosol,kind="AEROSOLS")
        
    def OnRemoveCloud(self,e):
        self.changeItem(self.myProfile.cloud_list,"no cloud to remove",
                   "Choose the clouds to remove from the profile",self.myProfile.removeCloud,kind="CLOUDS")
        
    def changeItem(self,liste_item,message1,message2,action,remove=True,kind="GASES"):    
        wx.BeginBusyCursor()
        myList=[]
        if remove == True :
            for item in liste_item :
                # can'u remove HO2 or O3
                #if not ( item == 'Q'or item == 'O3' ) :
                if not ( item == 'Q' ) :    
                    if  self.myProfile [item] != None :
                        myList.append(item)
        else :
            for item in liste_item :
                if  self.myProfile [item] == None :
                    myList.append(item)           
        if myList==[] :
            self.ShowInfoMessage(message1)
        else :    
            list_to_change=self. ShowDialogList(message2,myList)
            if list_to_change != None :
                for item in list_to_change :
                    if remove == True :
                        print "remove", item
                    else :
                        print "add",item    
                    action(item) 
                    if remove == True :
                        self.deleteRightPage(item)
                    else :
                        self.addRightPage(item)    
                # controle the coherence of clouds        
                if kind == "CLOUDS" :
                    print "control coherence cloud recompute CFRAC"
                    self.OnControlCFRAC()       
                self.replotLeftPage()
        wx.EndBusyCursor()       
            
     
                                
    def OnReplaceAerosolByClim(self,e):
        listItem=["Continental clean","Continental average","Continental polluted","Urban",
              "Desert","Maritime clean","Maritime polluted","Maritime tropical","Arctic","Antarctic"]
        selection=self.ShowDialogSingleChoice("Choose climatology", listItem)
        if selection != None :
            print "replace aerosols by climatology ",listItem[selection]
            self.myProfile.replaceByAerosolClim(selection+1)
        self.RePlotAll()    
        
    def ShowDialogSingleChoice(self,label,listItem):
        selection=None
        dlg=wx.SingleChoiceDialog(self,label,"",listItem)
        
        if (dlg.ShowModal() == wx.ID_OK):
            selection = dlg.GetSelection()
          
            print "Selection:  ", selection

        dlg.Destroy()
        return selection
    
                   
    def ShowDialogList(self,label,listItem):
        strings=None
        dlg=wx.MultiChoiceDialog(self,label,"",listItem)
        
        if (dlg.ShowModal() == wx.ID_OK):
            selections = dlg.GetSelections()
            strings = [listItem[x] for x in selections]
            print "Selections:  ", strings

        dlg.Destroy()
        return strings
    
    def OnMouseMove(self,e):
        """ print x y value of the left plot in the status bar  """
        pass

    def OnEditXAxe(self,e):
        mypage=self.nb.GetCurrentPage()
        item=mypage.theName
        (xmin,xmax)= mypage.axes.get_xlim()
        theScale=mypage.axes.get_xscale()
        if mypage.kind == "CLOUDS" :
            theIncrement=0.1
        else :
            theIncrement=10    
        dlg=AxesDialog(self,-1,"X axe edit",text="enter X limits for "+item,xmin0=xmin,xmax0=xmax,scale=theScale,increment=theIncrement)  
        
        if (dlg.ShowModal() == wx.ID_OK):
            #(xmin,xmax,scale) = dlg.GetSelections()
            (xmin,xmax) = dlg.GetSelections()      
            axesDef[item]["xlimits"]=(xmin,xmax)
            #if scale not in ("linear","log") : scale = theScale
            #axesDef[item]["xscale"]=scale
            mypage.OnPlot()
            mypage.Update()
        dlg.Close()
            
    def OnChangeProfile(self,e):
        mypage=self.nb.GetCurrentPage()
        item=mypage.theName
        (pmax,pmin)= mypage.axes.get_ylim()
        min_offset=min(mypage.x)
        max_offset=max(mypage.x)
        dlg=ComputeDialog(self,-1,"change profile values",text="enter value for "+item,pmin0=pmin,pmax0=pmax,limits_offset=(-min_offset,2*max_offset))  
        if (dlg.ShowModal() == wx.ID_OK):
            (pmin,pmax,scale,offset) = dlg.GetSelections()
            mypage.ComputeProfile(pmin,pmax,scale,offset)      
        dlg.Close()
        
           
    def MenuData(self):
        """ define the data for the menu
        """
        if self.edit :
            return( ("&File", # File Menu
                  ("Apply change","Apply the profile ",self.OnApplyChange,"applyChange",True,False),
                  ("Save profile","Save the profile file",self.OnSaveProfile,"saveProfile",True,False),
                  ("Save profile as","Save the profile file",self.OnSaveProfileAs,"saveProfileAs",True,False),
                  ('&Quit', 'Quit',self.OnClose,"quit",True,False)),
                ("&Edit",  # Edit Menu
                  ("Undo","Undo the last operation",self.OnUndo,"undo",True,False),
                  ("Redo","Redo the last operation",self.OnRedo,"redo",True,False),
                  ("","","","",True,False),
                  ("insert","mode for add or modify points",self.OnInsert,"insert",True,True),
                  ("remove","mode for suppress points",self.OnRemove,"remove",True,True),
                  ("","","","",True,False),  
                  ("change profile values","chage the profile values",self.OnChangeProfile,"changProfile",True,False ),
                  ("edit x axe","configure x axe",self.OnEditXAxe,"edit x axe",True,False ),
                  
                  ("","","","",True,False),
                  ("Add gas","add a gas",self.OnAddgas,"Add gas",True,False),
                  ("Remove gas","remove a gas",self.OnRemovegas,"Remove gas",True,False),
                  ("Add aerosol","add an aerosol",self.OnAddAerosol,"Add aerosol",True,False),
                  ("Remove aerosol","remove an aerosol",self.OnRemoveAerosol,"Remove aerosol",True,False),
                  ("Add cloud","add a cloud",self.OnAddCloud,"Add cloud",True,False),
                  ("Remove cloud","remove a cloud",self.OnRemoveCloud,"Remove cloud",True,False),
                  ("Replace Aerosol by clim","Replace Aerosol by clim",self.OnReplaceAerosolByClim,"Replace Aerosol by clim",True,False)),
                ("&Help",  # Help Menu
                  ("About","About screen",self.OnAbout,"about",True,False),
                  ("&Help","Help",self.OnHelp,"help",True,False)) )
        else :
            return( ("&File", # File Menu
                  ('&Quit', 'Quit',self.OnQuit,"quit",True,False)),
                ("&Help",  # Help Menu
                  ("About","About screen",self.OnAbout,"about",True,False)) )
                 
                
       
if  __name__ == "__main__": 
    import matplotlib
    print "version matplotlib :",matplotlib.__version__       
    p=rmodel.project.Project()
    
    p.openProfile(p.config.ENV["RTTOV_GUI_PREFIX"]+'/rttov_tests/cldaer101lev_allgas.H5',1) 
 #  
    ex = wx.App()
   
    myProfileView=ProfileView(None,p.myProfile)
    myProfileView.Bind(wx.EVT_MENU, myProfileView.OnApplyChange,myProfileView.items['applyChange'])

    
    profile=myProfileView.GetProfile()
    print "P"
    print profile['P']
    print "T"
    print profile["T"]
    print "loop" 
    ex.MainLoop()
    #ex.MainLoop()   
